searchData={"items":[{"type":"module","title":"SitemapXml","doc":"A module to fetch and parse sitemap XML.","ref":"SitemapXml.html"},{"type":"module","title":"SitemapXml.SitemapUrlTree","doc":"A module to fetch and parse sitemap XML concurrently and return a nested data structure.","ref":"SitemapXml.SitemapUrlTree.html"},{"type":"function","title":"SitemapXml.SitemapUrlTree.fetch_sitemap/1","doc":"Fetches the raw sitemap XML from the given URL.","ref":"SitemapXml.SitemapUrlTree.html#fetch_sitemap/1"},{"type":"function","title":"Examples - SitemapXml.SitemapUrlTree.fetch_sitemap/1","doc":"iex> SitemapXml.SitemapUrlTree.fetch_sitemap(\"https://web.site/sitemap.xml\")\n    {:ok, \"<?xml version=\"1.0\" encoding=\"UTF-8\"?><?xml-styleshee...\"}\n\n    iex> SitemapXml.SitemapUrlTree.fetch_sitemap(\"https://web.site/404.xml\")\n    {:error, \"HTTP error with status 404\"}","ref":"SitemapXml.SitemapUrlTree.html#fetch_sitemap/1-examples"},{"type":"function","title":"SitemapXml.SitemapUrlTree.fetch_url_tree/1","doc":"Fetches and parses the sitemap from the provided URL and returns a nested structure.","ref":"SitemapXml.SitemapUrlTree.html#fetch_url_tree/1"},{"type":"function","title":"Examples - SitemapXml.SitemapUrlTree.fetch_url_tree/1","doc":"iex> SitemapXml.SitemapUrlTree.fetch_url_tree(\"https://web.site/sitemap.xml\")\n    {:ok, [%{\"sitemap.xml\" => [%{url: \"https://web.site/page1\", lastmod: ..., priority: ...}, ...]}]}","ref":"SitemapXml.SitemapUrlTree.html#fetch_url_tree/1-examples"},{"type":"function","title":"SitemapXml.SitemapUrlTree.parse_sitemap/2","doc":"Parses the sitemap XML to extract URLs with their attributes, or processes nested sitemaps.","ref":"SitemapXml.SitemapUrlTree.html#parse_sitemap/2"},{"type":"function","title":"Examples - SitemapXml.SitemapUrlTree.parse_sitemap/2","doc":"iex> SitemapXml.SitemapUrlTree.parse_sitemap(\"https://web.site/sitemap.xml\", \" ... \")\n    {:ok, [%{\"sitemap.xml\" => [%{url: \"https://web.site/page1\", lastmod: ..., priority: ...}, ...]}]}\n\n    iex> SitemapXml.SitemapUrlTree.parse_sitemap(\"https://web.site/nested_sitemap.xml\", \" ... \")\n    ...","ref":"SitemapXml.SitemapUrlTree.html#parse_sitemap/2-examples"},{"type":"module","title":"SitemapXml.SitemapUrls","doc":"A module to fetch and parse URLs form sitemap XML concurrently.","ref":"SitemapXml.SitemapUrls.html"},{"type":"function","title":"SitemapXml.SitemapUrls.delete/3","doc":"Issues a DELETE request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"SitemapXml.SitemapUrls.html#delete/3"},{"type":"function","title":"SitemapXml.SitemapUrls.delete!/3","doc":"Issues a DELETE request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"SitemapXml.SitemapUrls.html#delete!/3"},{"type":"function","title":"SitemapXml.SitemapUrls.fetch_sitemap/1","doc":"Fetches the raw sitemap XML from the given URL.","ref":"SitemapXml.SitemapUrls.html#fetch_sitemap/1"},{"type":"function","title":"Examples - SitemapXml.SitemapUrls.fetch_sitemap/1","doc":"iex> SitemapXml.SitemapUrls.fetch_sitemap(\"https://web.site/sitemap.xml\")\n    {:ok, \" ... \"}\n\n    iex> SitemapXml.SitemapUrls.fetch_sitemap(\"https://web.site/404.xml\")\n    {:error, \"HTTP error with status 404\"}","ref":"SitemapXml.SitemapUrls.html#fetch_sitemap/1-examples"},{"type":"function","title":"SitemapXml.SitemapUrls.fetch_urls/1","doc":"Fetches and parses the sitemap from the provided URL.","ref":"SitemapXml.SitemapUrls.html#fetch_urls/1"},{"type":"function","title":"Examples - SitemapXml.SitemapUrls.fetch_urls/1","doc":"iex> SitemapXml.SitemapUrls.fetch_urls(\"https://web.site/sitemap.xml\")\n    {:ok, [\"https://web.site/page1\", \"https://web.site/page2\", ...]}","ref":"SitemapXml.SitemapUrls.html#fetch_urls/1-examples"},{"type":"function","title":"SitemapXml.SitemapUrls.get/3","doc":"Issues a GET request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"SitemapXml.SitemapUrls.html#get/3"},{"type":"function","title":"SitemapXml.SitemapUrls.get!/3","doc":"Issues a GET request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"SitemapXml.SitemapUrls.html#get!/3"},{"type":"function","title":"SitemapXml.SitemapUrls.head/3","doc":"Issues a HEAD request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"SitemapXml.SitemapUrls.html#head/3"},{"type":"function","title":"SitemapXml.SitemapUrls.head!/3","doc":"Issues a HEAD request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"SitemapXml.SitemapUrls.html#head!/3"},{"type":"function","title":"SitemapXml.SitemapUrls.options/3","doc":"Issues an OPTIONS request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"SitemapXml.SitemapUrls.html#options/3"},{"type":"function","title":"SitemapXml.SitemapUrls.options!/3","doc":"Issues a OPTIONS request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"SitemapXml.SitemapUrls.html#options!/3"},{"type":"function","title":"SitemapXml.SitemapUrls.parse_sitemap/1","doc":"Parses the sitemap XML to extract URLs or process nested sitemaps.","ref":"SitemapXml.SitemapUrls.html#parse_sitemap/1"},{"type":"function","title":"Examples - SitemapXml.SitemapUrls.parse_sitemap/1","doc":"iex> SitemapXml.SitemapUrls.parse_sitemap(\" ... \")\n    {:ok, [\"https://web.site/page1\", \"https://web.site/page2\"]}\n\n    iex> SitemapXml.SitemapUrls.parse_sitemap(\" ... \")\n    ...","ref":"SitemapXml.SitemapUrls.html#parse_sitemap/1-examples"},{"type":"function","title":"SitemapXml.SitemapUrls.patch/4","doc":"Issues a PATCH request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"SitemapXml.SitemapUrls.html#patch/4"},{"type":"function","title":"SitemapXml.SitemapUrls.patch!/4","doc":"Issues a PATCH request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"SitemapXml.SitemapUrls.html#patch!/4"},{"type":"function","title":"SitemapXml.SitemapUrls.post/4","doc":"Issues a POST request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"SitemapXml.SitemapUrls.html#post/4"},{"type":"function","title":"SitemapXml.SitemapUrls.post!/4","doc":"Issues a POST request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"SitemapXml.SitemapUrls.html#post!/4"},{"type":"function","title":"SitemapXml.SitemapUrls.process_headers/1","doc":"","ref":"SitemapXml.SitemapUrls.html#process_headers/1"},{"type":"function","title":"SitemapXml.SitemapUrls.process_request_body/1","doc":"","ref":"SitemapXml.SitemapUrls.html#process_request_body/1"},{"type":"function","title":"SitemapXml.SitemapUrls.process_request_headers/1","doc":"","ref":"SitemapXml.SitemapUrls.html#process_request_headers/1"},{"type":"function","title":"SitemapXml.SitemapUrls.process_request_options/1","doc":"","ref":"SitemapXml.SitemapUrls.html#process_request_options/1"},{"type":"function","title":"SitemapXml.SitemapUrls.process_request_params/1","doc":"","ref":"SitemapXml.SitemapUrls.html#process_request_params/1"},{"type":"function","title":"SitemapXml.SitemapUrls.process_request_url/1","doc":"","ref":"SitemapXml.SitemapUrls.html#process_request_url/1"},{"type":"function","title":"SitemapXml.SitemapUrls.process_response/1","doc":"","ref":"SitemapXml.SitemapUrls.html#process_response/1"},{"type":"function","title":"SitemapXml.SitemapUrls.process_response_body/1","doc":"","ref":"SitemapXml.SitemapUrls.html#process_response_body/1"},{"type":"function","title":"SitemapXml.SitemapUrls.process_response_chunk/1","doc":"","ref":"SitemapXml.SitemapUrls.html#process_response_chunk/1"},{"type":"function","title":"SitemapXml.SitemapUrls.process_response_headers/1","doc":"","ref":"SitemapXml.SitemapUrls.html#process_response_headers/1"},{"type":"function","title":"SitemapXml.SitemapUrls.process_response_status_code/1","doc":"","ref":"SitemapXml.SitemapUrls.html#process_response_status_code/1"},{"type":"function","title":"SitemapXml.SitemapUrls.process_status_code/1","doc":"","ref":"SitemapXml.SitemapUrls.html#process_status_code/1"},{"type":"function","title":"SitemapXml.SitemapUrls.process_url/1","doc":"","ref":"SitemapXml.SitemapUrls.html#process_url/1"},{"type":"function","title":"SitemapXml.SitemapUrls.put/4","doc":"Issues a PUT request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"SitemapXml.SitemapUrls.html#put/4"},{"type":"function","title":"SitemapXml.SitemapUrls.put!/4","doc":"Issues a PUT request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"SitemapXml.SitemapUrls.html#put!/4"},{"type":"function","title":"SitemapXml.SitemapUrls.request/1","doc":"Issues an HTTP request using a `Request` struct.\n\nThis function returns `{:ok, response}`, `{:ok, async_response}`, or `{:ok, maybe_redirect}`\nif the request is successful, `{:error, reason}` otherwise.","ref":"SitemapXml.SitemapUrls.html#request/1"},{"type":"function","title":"Redirect handling - SitemapXml.SitemapUrls.request/1","doc":"If the option `:follow_redirect` is given, HTTP redirects are automatically follow if\nthe method is set to `:get` or `:head` and the response's `status_code` is `301`, `302` or\n`307`.\n\nIf the method is set to `:post`, then the only `status_code` that get's automatically\nfollowed is `303`.\n\nIf any other method or `status_code` is returned, then this function returns a\nreturns a `{:ok, %HTTPoison.MaybeRedirect{}}` containing the `redirect_url` for you to\nre-request with the method set to `:get`.","ref":"SitemapXml.SitemapUrls.html#request/1-redirect-handling"},{"type":"function","title":"Examples - SitemapXml.SitemapUrls.request/1","doc":"request = %HTTPoison.Request{\n      method: :post,\n      url: \"https://my.website.com\",\n      body: \"{\\\"foo\\\": 3}\",\n      headers: [{\"Accept\", \"application/json\"}]\n    }\n\n    request(request)","ref":"SitemapXml.SitemapUrls.html#request/1-examples"},{"type":"function","title":"SitemapXml.SitemapUrls.request/5","doc":"Issues an HTTP request with the given method to the given url.\n\nThis function is usually used indirectly by `get/3`, `post/4`, `put/4`, etc\n\nArgs:\n  * `method` - HTTP method as an atom (`:get`, `:head`, `:post`, `:put`,\n    `:delete`, etc.)\n  * `url` - target url as a binary string or char list\n  * `body` - request body. See more below\n  * `headers` - HTTP headers as an orddict (e.g., `[{\"Accept\", \"application/json\"}]`)\n  * `options` - Keyword list of options\n\nBody: see type `HTTPoison.Request`\n\nOptions: see type `HTTPoison.Request`\n\nThis function returns `{:ok, response}`, `{:ok, async_response}`, or `{:ok, maybe_redirect}`\nif the request is successful, `{:error, reason}` otherwise.","ref":"SitemapXml.SitemapUrls.html#request/5"},{"type":"function","title":"Redirect handling - SitemapXml.SitemapUrls.request/5","doc":"If the option `:follow_redirect` is given, HTTP redirects are automatically follow if\nthe method is set to `:get` or `:head` and the response's `status_code` is `301`, `302` or\n`307`.\n\nIf the method is set to `:post`, then the only `status_code` that get's automatically\nfollowed is `303`.\n\nIf any other method or `status_code` is returned, then this function returns a\nreturns a `{:ok, %HTTPoison.MaybeRedirect{}}` containing the `redirect_url` for you to\nre-request with the method set to `:get`.","ref":"SitemapXml.SitemapUrls.html#request/5-redirect-handling"},{"type":"function","title":"Examples - SitemapXml.SitemapUrls.request/5","doc":"request(:post, \"https://my.website.com\", \"{\\\"foo\\\": 3}\", [{\"Accept\", \"application/json\"}])","ref":"SitemapXml.SitemapUrls.html#request/5-examples"},{"type":"function","title":"SitemapXml.SitemapUrls.request!/5","doc":"Issues an HTTP request with the given method to the given url, raising an\nexception in case of failure.\n\n`request!/5` works exactly like `request/5` but it returns just the\nresponse in case of a successful request, raising an exception in case the\nrequest fails.","ref":"SitemapXml.SitemapUrls.html#request!/5"},{"type":"function","title":"SitemapXml.SitemapUrls.start/0","doc":"Starts HTTPoison and its dependencies.","ref":"SitemapXml.SitemapUrls.html#start/0"},{"type":"function","title":"SitemapXml.SitemapUrls.stream_next/1","doc":"Requests the next message to be streamed for a given `HTTPoison.AsyncResponse`.\n\nSee `request!/5` for more detailed information.","ref":"SitemapXml.SitemapUrls.html#stream_next/1"},{"type":"type","title":"SitemapXml.SitemapUrls.body/0","doc":"","ref":"SitemapXml.SitemapUrls.html#t:body/0"},{"type":"type","title":"SitemapXml.SitemapUrls.headers/0","doc":"","ref":"SitemapXml.SitemapUrls.html#t:headers/0"},{"type":"type","title":"SitemapXml.SitemapUrls.method/0","doc":"","ref":"SitemapXml.SitemapUrls.html#t:method/0"},{"type":"type","title":"SitemapXml.SitemapUrls.options/0","doc":"","ref":"SitemapXml.SitemapUrls.html#t:options/0"},{"type":"type","title":"SitemapXml.SitemapUrls.params/0","doc":"","ref":"SitemapXml.SitemapUrls.html#t:params/0"},{"type":"type","title":"SitemapXml.SitemapUrls.request/0","doc":"","ref":"SitemapXml.SitemapUrls.html#t:request/0"},{"type":"type","title":"SitemapXml.SitemapUrls.url/0","doc":"","ref":"SitemapXml.SitemapUrls.html#t:url/0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,49]}}